/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1996  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//                      Keio University (Matsushita Lab.)
//                      All rights reserved.
//  Please first read the full copyright statement in the file LICENSE.
//  Permission to copy this software, to redistribute it on a nonprofit
//  basis, and to use it for any purpose, is hereby granted, provided that 
//  this license information and copyright notice appear in all copies. 
*/

#ifndef EVENTMANAGERHT_H
#define EVENTMANAGETHT_H
#ifdef __GNUG__
#pragma interface
#endif

#include <WWWApp.h>


class EventManagerHT_impl
{
    friend class EventManagerHT;
 protected:
    EventManagerHT_impl() {}
    virtual ~EventManagerHT_impl() {}
    
    virtual int register_event(SOCKET, HTRequest*, SockOps,
			       HTEventCallback*, HTPriority) = 0;
    virtual int unregister_event(SOCKET, SockOps) = 0;
};


class EventManagerHT
{
 protected:
    // primitive functions
    EventManagerHT();
    virtual ~EventManagerHT() {}

    // libwww callback interface
    static int ht_register(SOCKET fd, HTRequest* req, SockOps ops,
			   HTEventCallback* callback, HTPriority pri)
	{ return impl_->register_event(fd, req, ops, callback, pri); }

    static int ht_unregister(SOCKET fd, SockOps ops)
	{ return impl_->unregister_event(fd, ops); }
    
    static EventManagerHT_impl* impl_;
};

#endif /* EVENTMANAGERHT_H */
