/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1995-1996  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//                           Keio University (Matsushita Lab.)
//                           All rights reserved.
//  Please first read the full copyright statement in the file LICENSE.
//  Permission to copy this software, to redistribute it on a nonprofit
//  basis, and to use it for any purpose, is hereby granted, provided that 
//  this license information and copyright notice appear in all copies. 
*/

#ifdef __GNUG__
#pragma implementation
#endif

#include "linkview.h"
#include "NodeInfo.h"


NodeInfo::NodeInfo(
    string t = "Untitled",
    string m = ""):
    title(t), doi(0), x(0), y(0), z(0), r(0),
    eye(0), eyebrow(0), mouth(0),
    scanned(false), disabled(false), visited(false), written(0),
    x_2d(0), y_2d(0),
    http_status(0), content_type(m), content_length(0),
    last_get(0), last_head(0), expires(0), last_modified(0),
    icon_changed(true), label_changed(true),
    icon_list(0), label_list(0)
{}


void
NodeInfo::fill_variables()
{
    int len = content.length();
    n_j_letters = n_e_letters = 0;
    for (int i = 0; i < len; i++) {
	if (content[i] & 0x80) ++n_j_letters;
	else                   ++n_e_letters;
    }
    n_j_letters /= 2;
}


LinkInfo::LinkInfo(
    string f = "",
    string a = "",
    string m = ""):
    frag(f), anchor(a), method(m),
    scanned(false), visited(false)
{}

