/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1996-1997  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//                           Keio University (Matsushita Lab.)
//                           All rights reserved.
//  Please first read the full copyright statement in the file LICENSE.
//  Permission to copy this software, to redistribute it on a nonprofit
//  basis, and to use it for any purpose, is hereby granted, provided that 
//  this license information and copyright notice appear in all copies. 
*/

#ifndef NODEMAPPER_H
#define NODEMAPPER_H
#ifdef __GNUG__
#pragma interface
#endif

#include "Web.h"


class NodeMapper
{
 public:
    NodeMapper(string x_title, string y_title);
    virtual ~NodeMapper() {}

    virtual void   configure(Web*) {}
    virtual void   layout(Web::node*) = 0;
    virtual bool   x_label(int, float&, string&) = 0;
    virtual bool   y_label(int, float&, string&) = 0;
    float   z_step()     const { return z_step_; }
    float   def_radius() const { return def_radius_; }
    
    string x_title() const { return x_title_; }
    string y_title() const { return y_title_; }
    void   x_title(string t) { x_title_ = t; }
    void   y_title(string t) { y_title_ = t; }

 private:
    string x_title_;
    string y_title_;
    float  z_step_;
    float  def_radius_;
};

#endif /* NODEMAPPER_H */
