/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1995-1996  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//                           Keio University (Matsushita Lab.)
//                           All rights reserved.
//  Please first read the full copyright statement in the file LICENSE.
//  Permission to copy this software, to redistribute it on a nonprofit
//  basis, and to use it for any purpose, is hereby granted, provided that 
//  this license information and copyright notice appear in all copies. 
*/

#include "linkview.h"
#include "copy_line.h"

#include <ctype.h>
#include <istream>
#include <ostream>


istream&
copy_line(
    istream& in,
    ostream& out)
{
    const unsigned char CR = '\015';
    const unsigned char LF = '\012';
    
    unsigned char ch = '\0';
    while (in.get(ch) && (ch == ' ' || ch == '\t'))
	;
    switch (ch) {
     case CR:
	if (in.peek() == LF) (void) in.get(ch);
	return in;
     case LF:
     case '\0':
	return in;
    }

    int n = 0;
    do { 
	if (isspace(ch)) n++;
	else n = 0;
	out.put(ch);
	ch = '\0';
    } while (in.get(ch) && ch != CR && ch != LF && ch != '\0');
    out.seekp(-n, ios::cur);

    if (ch == CR && in.peek() == LF) (void) in.get(ch);
    return in;
}
