#! /usr/local/bin/perl -w
#/*
#//  The Natto View
#//
#//  Copyright (c) 1996  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
#//                      Keio University (Matsushita Lab.)
#//
#//  Please first read the full copyright statement in the file LICENSE.
#//  The code in this file may be used, copied and redistributed under the
#//  same terms as perl itself (see the files README, Copying and Artistic
#//  in the perl distribution).
#*/

use strict;
#use diagnostics;

print <<END;

/* Don't modify. This is a generated file. */

/*
//  The Natto View
//
//  Copyright (c) 1996  Hidekazu Shiozawa <shiozawa\@myo.inst.keio.ac.jp>
//                      Keio University (Matsushita Lab.)
*/

#include <stddef.h>
#include <WWWUtil.h>
#include <HTMLPDTD.h>
#include "HTMLexDTD.h"

END

print "/* Entity Names */\n";
print "PRIVATE const char* entities\[\] = {\n";
while (<>) {
    last unless /^0-ENTITY\s*(\S+)/;
    print "\t\"$1\",\n";
}
print "};\n\n";


print "/* Element Attributes */\n";
my $enttab = '';
do {
    if (/^1-ELEMENT\s*(\S+)\s*(\S+)\s*(\S+)\s*(\S+)?/) {
        if ($2 eq '0-new') {
            print "\t{ NULL }\n};\n\n" if $enttab;
            print "PRIVATE attr $1_attr\[\] = {\n";

            my $name  = "\"" . uc $1 . "\"";
	    my $attrs = "$1_attr";
	    my $var   = uc $1;
	    $var =~ s/-/_/g;
	    my $nattr = "HTMLex_${var}_ATTRIBUTES";
	    my $type  = $4 eq 'O' ? "SGML_EMPTY" : "SGML_MIXED";
	    $type = "SGML_LITERAL" if $name =~ /(listings)|(plaintext)|(xmp)/;
	    $enttab .= "{ $name,\t$attrs,\t$nattr,\t$type },\n";
	}
	else {
	    print "\t{ \"" . uc $3 . "\" },\n";
	}
    }
} while (<>);

print "\t{ NULL }\n};\n\n";

print "/* Elements */\n";
print "PRIVATE HTTag tags\[\] = {\n$enttab};\n";

print <<END;


PUBLIC const SGML_dtd HTMLex_dtd = {
    tags,     sizeof(tags)/sizeof(tags\[0\]),
    entities, sizeof(entities)/sizeof(entities\[0\])
};
END
