#! /usr/local/bin/perl -w
#/*
#//  The Natto View
#//
#//  Copyright (c) 1996  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
#//                      Keio University (Matsushita Lab.)
#//
#//  Please first read the full copyright statement in the file LICENSE.
#//  The code in this file may be used, copied and redistributed under the
#//  same terms as perl itself (see the files README, Copying and Artistic
#//  in the perl distribution).
#*/

use strict;
#use diagnostics;

my $elem = '';
my @elems = ();

print <<END;

/* Don't modify. This is a generated file. */

/*
//  The Natto View
//
//  Copyright (c) 1996  Hidekazu Shiozawa <shiozawa\@myo.inst.keio.ac.jp>
//                      Keio University (Matsushita Lab.)
*/

#ifndef HTMLexDTD_H
#define HTMLexDTD_H

#include <HTStruct.h>
#include <SGML.h>

END

my $nentities;

print "/* HTML Element Attributes */\n";
while (<>) {
    if (/^0-ENTITY/) {
        $nentities++;
    }
    elsif (/^1-ELEMENT\s*(\S+)\s*(\S+)\s*(\S+)/) {
        if ($elem ne uc $1) {
            print "\tHTMLex_${elem}_ATTRIBUTES\n};\n\n" if $elem;
	    $elem = uc $1;
	    print "/* $elem */\nenum {\n";
	    $elem =~ s/-/_/g;
	    push(@elems, $elem);
	}
	if ($2 eq "1-att") {
	    my $attr = uc $3;
	    $attr =~ s/-/_/g;
	    print "\tHTMLex_${elem}_${attr},\n";
	}
    }
}
print "\tHTMLex_${elem}_ATTRIBUTES\n};\n";
print "\n\n";

print "/* HTML Elements */\ntypedef enum _HTMLexElement {\n";
foreach $elem (@elems) {
    print "\tHTMLex_${elem},\n";
}
print "\tHTMLex_ELEMENTS\n} HTMLexElement;\n";

print <<END;

#define HTMLex_ENTITIES  $nentities

extern const SGML_dtd HTMLex_dtd;

#endif /* HTMLexDTD_H */
END
