/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1996  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//                      Keio University (Matsushita Lab.)
//                      All rights reserved.
//  Please first read the full copyright statement in the file LICENSE.
//  Permission to copy this software, to redistribute it on a nonprofit
//  basis, and to use it for any purpose, is hereby granted, provided that 
//  this license information and copyright notice appear in all copies. 
*/

#ifndef SOCKETSTREAM_H
#define SOCKETSTREAM_H
#ifdef __GNUG__
#pragma interface
#endif

//////////////////////////////////////////////////////////////////////////////
//  socketstream.h -- iostream-style socket interface
//

#include <sys/types.h>
#include <fstream>


//////////////////////////////////////////////////////////////////////////////
//  socketstream -- fstream wrapper for socket
//
class socketstream: public fstream
{
 public:
    socketstream() {}
    socketstream(int fd): fstream(fd) {}
    socketstream(const char* host, u_short port) { open(host, port); }
    void open(const char* host, u_short port);
};

#endif /* SOCKETSTREAM_H */
