/*                                               -*- Mode:C++; tab-width: 8 -*-
//  The Natto View
//
//  Copyright (c) 1996-1997  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
//                           Keio University (Matsushita Lab.)
//                           All rights reserved.
//  Please first read the full copyright statement in the file LICENSE.
//  Permission to copy this software, to redistribute it on a nonprofit
//  basis, and to use it for any purpose, is hereby granted, provided that 
//  this license information and copyright notice appear in all copies. 
*/

#ifndef XTINTER_H
#define XTINTER_H
#ifdef __GNUG__
#pragma interface
#endif

#include <X11/Intrinsic.h>

#define XTINTER_FAST(callback, call_data_t) \
    void callback(Widget, call_data_t); \
    static void xt_ ## callback(Widget w, XtPointer me, XtPointer cdata) \
	{ ((XTINTER_CLASS*) me)->callback(w, (call_data_t) cdata); }

#define XTINTER_FAST_ADD(w, name, callback) \
    XtAddCallback(w, name, xt_ ## callback, (XtPointer) this)

#define XTINTER_FAST_REMOVE(w, name, callback) \
    XtRemoveCallback(w, name, xt_ ## callback, (XtPointer) this)


#define XTINTER_ACTION(callback) \
void callback(XEvent*, String*, Cardinal*); \
static void xt_ ## callback(Widget w, XEvent* event, String* argv, Cardinal* argc) \
{ \
    XTINTER_CLASS* me; \
    XtVaGetValues(w, XmNuserData, me, NULL); \
    me->callback(event, argv, argc); \
}

#endif /* XTINTER_H */
